﻿
var currentAttribute;
var currentUID;
var selectedChecklistItems;
var filteredQuestionList;
var savedChecklistItems;

function onCheckListClick(e) {


    var item = filteredQuestionList.getByUid(e.item[0].attributes[0].nodeValue);

    if (questionsRootDataSource.at(questionsRootDataSource.indexOf(item)).selected === 0) {
        questionsRootDataSource.at(questionsRootDataSource.indexOf(item)).selected = 1;
    }
    else {
        questionsRootDataSource.at(questionsRootDataSource.indexOf(item)).selected = 0;
    }

    var listview = $("#checklistdetail-listview").data("kendoMobileListView");
    listview.refresh();


    //save this stuff as a separate array so we don't need to loop through the data source to save things.
    var questionId = String(questionsRootDataSource.at(questionsRootDataSource.indexOf(item)).questionId);
    
    if (selectedChecklistItems.inArray(questionId)) {
        selectedChecklistItems.removeByValue(questionId);
    }
    else {
        selectedChecklistItems.push(questionId);
    }

  

}
function checklistInit(e) {
   
    e.view.element.find("#checklist-listview").kendoMobileListView({
        dataSource: mainDataSource,
        template: $("#checkTopItemTemplate").html()
    })
    .kendoTouch({
        filter: ">li",
        enableSwipe: true,
        touchstart: touchstart,
        tap: navigate
    });

    //we need to pre-select the items in the data source based on saved values
    loadStoredChecklistItems();
    
}

function loadStoredChecklistItems() {
    //pull the data from local storage
    savedChecklistItems = window.localStorage.getItem("selectedChecklistItems");

    //spit them out to an array
    if (savedChecklistItems) {
        selectedChecklistItems = savedChecklistItems.split(",");
      
        //then update the main data source
        questionsRootDataSource.read();

        var data = questionsRootDataSource.data();
     
        for (h = 0; h < selectedChecklistItems.length; h++) {
            for (i = 0; i < data.length; i++) {
                if (String(data[i].questionId) === String(selectedChecklistItems[h])) {
                    questionsRootDataSource.at(i).selected = 1;
                }
            }
        }
    }
}

function navigate(e) {
    var itemUID = $(e.touch.currentTarget).data("uid");
    var model = mainDataSource.getByUid(itemUID);

    if (model.typeId === 7) {
        navigateToURL("html/health/email-medical-team.html");
    }
    else {
        navigateToURL("#checklist-questionView?uid=" + itemUID);
    }
   
}

function touchstart(e) {
    var target = $(e.touch.initialTouch),
        listview = $("#checklist-listview").data("kendoMobileListView"),
        model,
        button = $(e.touch.target).find("[data-role=button]:visible");

    if (target.closest("[data-role=button]")[0]) {
        model = mainDataSource.getByUid($(e.touch.target).attr("data-uid"));
        dataSource.remove(model);

        //prevent `swipe`
        this.events.cancel();
        e.event.stopPropagation();
    } else if (button[0]) {
        button.hide();

        //prevent `swipe`
        this.events.cancel();
    } else {
        listview.items().find("[data-role=button]:visible").hide();
    }
}

function mainShow(e) {

    var mainList = $('#checklist-listview').data('kendoMobileListView');
    mainList.refresh();

}

//Methods for the listview-style details

function checklistDetailShow(e) {

    //make sure we're scrolled to the top of the page
    resetScrollPosition(e);

    var model = mainDataSource.getByUid(e.view.params.uid);
    currentAttribute = model;
    currentUID = e.view.params.uid;

    //set navigation bar title
    var navbar = app.view()
   .header
   .find(".km-navbar")
   .data("kendoMobileNavBar");

    navbar.title(model.title);

    //read in existing items
    selectedChecklistItems = new Array();

   

    //now filter the data source
    filteredQuestionList = questionsRootDataSource;
    if (model.typeId === 0) {
        filteredQuestionList.filter({ field: "selected", operator: "equals", value: 1 });

        var view = filteredQuestionList.view();
        if (view.length > 0) {
            $('#amtSendButton').show();
        }
        else {
            $('#amtSendButton').hide();
        }
    }
    else {
        filteredQuestionList.filter({ field: "parentId", operator: "equals", value: model.typeId });
        $('#amtSendButton').hide();
    }

    e.view.element.find("#checklistdetail-listview").kendoMobileListView({
        dataSource: filteredQuestionList,
        template: "# if(selected == 1) {# <img src='images/icons/check-selected.png' class='checklistImage' id='${questionId}' alt='checkbox checked'> #}else{# <img src='images/icons/check-unselected.png' class='checklistImage' id='${questionId}' alt='checkbox unchecked'></img> #}# <p class='checklistText'><label for='${questionId}'>${name}</label></p>"
    })

}


function checklistDetailInit(e) {
    var view = e.view;

   

    //add click event to the listview
    e.view.element.find("#checklistdetail-listview").kendoMobileListView({
        click: onCheckListClick
    })

    //define function for the done button
    view.element.find("#done").data("kendoMobileButton").bind("click", function () {


        saveItems();

        navigateToURL("#:back");
    });

    //view.element.find("#mailTeam").data("kendoMobileButton").bind("click", function () {


    //    saveItems();

    //    kendo.mobile.application.navigate("html/health/email-medical-team.html?include=1");
    //});
}

function saveItems()
{
    var i;
    var stringValue = '';
    for (i = 0; i < selectedChecklistItems.length; i++) {
        stringValue += String(selectedChecklistItems[i]) + ',';
    }
    //cut off the last comma
    stringValue = stringValue.substring(0, stringValue.length - 1);

    //now we need to save the string to local storage
    window.localStorage.setItem("selectedChecklistItems", stringValue);
}


var mainDataSource = new kendo.data.DataSource({
    data: [
     
      { name: "My Pressure Ulcer", title: "My Ulcer",  typeId: 2, image: "images\\learn\\doc_listening-sm.png" },
      { name: "Home-based Care", title: "Home Care", typeId: 1, image: "images\\learn\\home-care2-sm.png" },
      { name: "Tests and Procedures", title: "Tests", typeId: 3, image: "images\\learn\\x-ray-sm.png" },
      { name: "How Doctor's Office Works", title: "Office", typeId: 4, image: "images\\learn\\dr-office-2-sm.png" },
      { name: "Cost of Medical Care", title: "Costs", typeId: 5, image: "images\\learn\\cost2-sm.png" },
      { name: "Discharged from VA Facility", title: "Discharge", typeId: 6, image: "images\\learn\\discharge-sm.png" },
      { name: "View Saved Questions", title: "Saved Questions", typeId: 0, image: "images\\learn\\save2-sm.png" }
      //,{ name: "Email Medical Team", typeId: 7, image: "images\\learn\\email-med-team.png" }
    ]
});

