﻿window.onresize = function () {
    adjustDivHeight();
}

function adjustDivHeight() {
    $('#plate-div').height($('#fullimage').height())
};


var currentSelected = 'full'
var frontVisible = 1
var init = 0 //hack, was getting initialized twice for some reason

function cmpInit () {

    initContent();

    if (init === 0) {
        init = 1;
        //set up the image map to scale
        $('img[usemap]').rwdImageMaps();

        //prime the listview, but don't set datasource yet.  that will be set later.
        $("#cmp-listview").kendoMobileListView({
            template: $("#customListViewNoDescriptionTemplate").html(),
            click: listViewLinkClick
        });


        $('area').on('mousedown', function () {

            //clear the selected of all the existing tabs, just in case
            $("map > area").attr("aria-selected", "false");

            var toBeSelected = $(this).attr('alt')

            //if the currenty selected is the one that's clicked, then we need to show the 'full' again
            if (currentSelected === toBeSelected) {
                toBeSelected = 'full'
            } else {
                //otherwise we want to set the aria-selected for the current element for accessibility
                $(this).attr("aria-selected", "true");
            }

            if (frontVisible === 1) {
                swapSection(toBeSelected, '#backimage', '#fullimage')
                frontVisible = 0
            }
            else {
                swapSection(toBeSelected, '#fullimage', '#backimage')
                frontVisible = 1
            }

            currentSelected = toBeSelected;
        });

    }

}

   




function selectLinksSection(objectTitle) {

  
    var rootPath = '..\\..\\html\\nutrition\\'

    if (objectTitle === 'full') {
        $('#cmp-listview').fadeOut();
    }
    else {

        $('#cmp-listview').fadeIn();

        var cmpDataSource;
        if (objectTitle === 'fruits') {
            cmpDataSource = fruitDataSource;
        }
        else if (objectTitle === 'dairy') {
            cmpDataSource = dairyDataSource;
        }
        else if (objectTitle === 'vegetables') {
            cmpDataSource = vegetableDataSource;
        }
        else if (objectTitle === 'grains') {
            cmpDataSource = grainDataSource;
        }
        else  {
            cmpDataSource = proteinDataSource;
        }

       
        //$("#cmp-listview").kendoMobileListView({
        //    dataSource: cmpDataSource,
        //    template: $("#customListViewNoDescriptionTemplate").html(),
        //    click: listViewLinkClick
        //});

        var listView = $("#cmp-listview").data("kendoMobileListView");
        listView.setDataSource(cmpDataSource);
        // refreshes the list view
        //listView.refresh();
    }
  
};


function swapSection(objectTitle, backControl, frontControl) {



    var imagePath = 'images\\nutrition\\myplate_' + objectTitle + '.png'

    //swap the z-indexes so that the 'front' control is on top, since this one will be fading out
    $(backControl).attr('z-index', 10)
    $(frontControl).attr('z-index', 1)

    //set the back control's value and fade it in, since it may be faded out from a previous action
    $(backControl).attr('src', imagePath);
    $(backControl).fadeIn();

    //finally, fade out the previous front control so that it reveals the new one
    $(frontControl).fadeToggle();

    //now we need to change out the links section
    selectLinksSection(objectTitle);

};


var dairyDataSource = new kendo.data.DataSource({
    data: [
      { name: "Items", image: "images\\learn\\food-icon-dairy.png", url: "html/nutrition/items-dairy.html" },
      { name: "Benefits", image: "images\\learn\\icon-benefits-blue.png", url: "html/nutrition/benefits-dairy.html" },
      { name: "Portions", image: "images\\learn\\icon-portions-blue.png", url: "html/nutrition/portions-dairy.html" },
      { name: "Eating More", image: "images\\learn\\icon-eating-more-blue.png", url: "html/nutrition/eating-dairy.html" },
      { name: "Allergies", image: "images\\learn\\icon-allergy-blue.png", url: "html/nutrition/allergy-dairy.html" }
      
     
    ]
});

var fruitDataSource = new kendo.data.DataSource({
    data: [
        { name: "Items", image: "images\\learn\\food-icon-fruit.png", url: "html/nutrition/items-fruits.html" },
      { name: "Benefits", image: "images\\learn\\icon-benefits-red.png", url: "html/nutrition/benefits-fruits.html" },
      { name: "Portions", image: "images\\learn\\icon-portions-red.png", url: "html/nutrition/portions-fruits.html" },
      { name: "Eating More", image: "images\\learn\\icon-eating-more-red.png", url: "html/nutrition/eating-fruits.html" },
      { name: "Allergies", image: "images\\learn\\icon-allergy-red.png", url: "html/nutrition/allergy-fruits.html" }
      

    ]
});

var grainDataSource = new kendo.data.DataSource({
    data: [
      { name: "Items", image: "images\\learn\\food-icon-grains.png", url: "html/nutrition/items-grains.html" },
      { name: "Benefits", image: "images\\learn\\icon-benefits-orange.png", url: "html/nutrition/benefits-grains.html" },
      { name: "Portions", image: "images\\learn\\icon-portions-orange.png", url: "html/nutrition/portions-grains.html" },
      { name: "Eating More", image: "images\\learn\\icon-eating-more-orange.png", url: "html/nutrition/eating-grains.html" },
      { name: "Allergies", image: "images\\learn\\icon-allergy-orange.png", url: "html/nutrition/allergy-grains.html" }
     

    ]
});

var proteinDataSource = new kendo.data.DataSource({
    data: [
      { name: "Items", image: "images\\learn\\food-icon-protein.png", url: "html/nutrition/items-protein.html" },
      { name: "Benefits", image: "images\\learn\\icon-benefits-purple.png", url: "html/nutrition/benefits-protein.html" },
      { name: "Portions", image: "images\\learn\\icon-portions-purple.png", url: "html/nutrition/portions-protein.html" },
      { name: "Eating More", image: "images\\learn\\icon-eating-more-purple.png", url: "html/nutrition/eating-protein.html" },
      { name: "Allergies", image: "images\\learn\\icon-allergy-purple.png", url: "html/nutrition/allergy-protein.html" }
    ]
});

var vegetableDataSource = new kendo.data.DataSource({
    data: [
      { name: "Items", image: "images\\learn\\food-icon-vegetable.png", url: "html/nutrition/items-vegetables.html" },
      { name: "Benefits", image: "images\\learn\\icon-benefits-green.png", url: "html/nutrition/benefits-vegetables.html" },
      { name: "Portions", image: "images\\learn\\icon-portions-green.png", url: "html/nutrition/portions-vegetables.html" },
      { name: "Eating More", image: "images\\learn\\icon-eating-more-green.png", url: "html/nutrition/eating-vegetables.html" },
      { name: "Allergies", image: "images\\learn\\icon-allergy-green.png", url: "html/nutrition/allergy-vegetables.html" }
      

    ]
});

