﻿//Global constants
var contactsFilename = 'contacts.txt';


var enableDSLogonTransmission = false;
/*
    TODO when DS Logon is ready:

    1.  Turn this flag to true
    2.  in myhealth.js, find the flag in the submit button function
    3.  remove the redirect from writeJournalEntryToDisk function (since you need to do your own thing first).
    4.  PURServices.js holds the transmission code for the oAuth 2.0 logins.  will need to edit to accept the postable object from myhealth.js
    5.  build a 'submission failed/resubmit' ability 
*/

/**
 * Generates a GUID string.
 * @returns {String} The generated GUID.
 * @example af8a8416-6e18-a307-bd9c-f2c947bbb3aa
 * @author Slavik Meltser (slavik@meltser.info).
 * @link http://slavik.meltser.info/?p=142
 */
function guid() {
    function _p8(s) {
        var p = (Math.random().toString(16) +"000000000").substr(2, 8);
        return s ? "-" +p.substr(0, 4) + "-" +p.substr(4, 4): p;
}
    return _p8() +_p8(true) +_p8(true) +_p8();
}

function intGuid() {
    //var i = new Date().getTime();
    //return (i & 0xffff);
    return (1 + Math.floor(Math.random() * 32000));
}

//image slider/panel methods
function hideAll() {

    //need to aria-hidden the 0-index as well
    var element = $("[data-role=page]").eq(0);
    if (element) {
        element.attr("aria-hidden", "true");
    }


    //then hide all the detail content secions and aria-hidden all the pages
    for (var i = 1; i < 14; i++) {
        var name = '.detail' + i;
        $(name).hide();
        $(name).attr('aria-hidden', true);

        var element = $("[data-role=page]").eq(i);
        if (element) {
            element.attr("aria-hidden", "true");
        }
        
    }

}

function change(e) {

    hideAll();

    //set the current page visible to the screen reader
    var element = $("[data-role=page]").eq(e.page);
    element.attr("aria-hidden", "false");
   

    //then set the detail view visible to both
    var str = '.detail' + (e.page + 1);
    $(str).show();
    $(str).attr('aria-hidden', false);
}


function prevArrowClick(e) {

    var containerId = e.sender.element[0].parentElement.children[0].id;
    var scrollviewName = "#" + containerId
    var scrollView = $(scrollviewName).data("kendoMobileScrollView");

    if (scrollView.page > 0) {
        $(scrollviewName).data("kendoMobileScrollView").scrollTo(scrollView.page - 1);
    }
}

function nextArrowClick(e) {
   
    var containerId = e.sender.element[0].parentElement.children[0].id;
    var scrollviewName = "#" + containerId
    var scrollView = $(scrollviewName).data("kendoMobileScrollView");

    if (scrollView.page < scrollView._content.pageCount - 1) {
        $(scrollviewName).data("kendoMobileScrollView").scrollTo(scrollView.page + 1);
    }
}



//cleanup functions
function removeView(view) {
    if ($(view)) {
        $(view).remove();
        console.log("View Removed: " + view);
    }
}

function refresh(e) {

    console.log("Total: ", e.pageCount, " Current: ", e.page);

    e.data("kendoMobileScrollView").scrollTo(0);
}


function initContent() {
    //console.log(app.view().id);
    addFooter();

    bindPopoverToTaggedItems();

    // clean up
    var panelbar = $(app.view().contentElement()).find('#panelbar');
    $(panelbar).kendoPanelBar({
        collapse: onCollapse,
        expand: onExpand
        //expandMode: "single"
    });


    //var panelBar = $("#panelbar").kendoPanelBar({
    //    collapse: onCollapse
    //});


}
function onExpand(e) {
   // $(e.item).setAttribute("aria-expanded", true);
}
function onCollapse(e) {

    $(e.item).children().removeClass('k-state-selected');
    $(e.item).children().removeClass('k-state-focused');
   // $(e.item).setAttribute("aria-expanded", false);
}




function updateBreadcrumb(e) {

    
   captureNextBreadcrumbItem({
        href: app.view().id,
        title: app.view().title,
        maxBreadcrumbs: 5,
        fullHistory: false
    });
    var breadcrumbHistory = buildBreadcrumbHistory();
    showBreadcrumb(breadcrumbHistory);

   
    resetScrollPosition(e);
   
}

function resetScrollPosition(e) {
    //scroll everything back to top on show for section 508
    //app.scroller() is undefined when using native scrolling
    app.scroller().reset();
    console.log("scroll position reset")
    window.scrollTo(0, 0);

    //$(app.view().contentElement() + ' *:a[type!=hidden]:first').focus();
    //$(app.view().contentElement()).find('a:first').focus();
   // console.log("You are currently watching " + app.view().contentElement());
    //var headerClass ="viewTitleStyle";

    //var x = app.view();
    //var id = app.view().wrapper[0].attributes['id'].value;
    //console.log("id: "+ app.view().wrapper[0].attributes['id'].value)

    
    //$('#' + id +' .' + headerClass).attr('tabindex', '-1').css('outline', 'none');
    //$('#' + id + ' .' + headerClass).focus();

    //var headerClass = app.view().header[0].children[0].children[0].className;
    //var id = app.view().wrapper[0].attributes['id'].value;
    //$('#' + id + ' .viewTitleStyle').attr('tabindex', '-1');
    //$('#' + id + ' .viewTitleStyle').focus();

    $('#focusContainer').focus();

    //$(app.view().contentElement()).attr('tabindex', -1);
    //$(app.view().contentElement()).focus();

   // e.view.header.children[0].focus();

}

function clearBreadcrumb() {


    sessionStorage.breadcrumbList = '';

}


function showBreadcrumb(breadcrumbHistory) {
    var breadcrumb = $(app.view().contentElement()).find('ol.breadcrumb');
    $(breadcrumb).html(breadcrumbHistory);
}

function addFooter() {

    // add footer container
    var container = $(app.view().contentElement()).find(".container");
    container.append('<div class ="row pg-footer"><div class="col-xs-12"><footer></footer></div></div>');

    // add disclaimer to footer
    var footer = container.find(".pg-footer footer");
    $('<div>', { "class": "disclaimer", "html": "<p>If you have any concerns, please call your qualified health care provider, or seek immediate medical attention.</p>" }).appendTo(footer);

    // add source referneces to footer
    addSourceReferences();
   
    // add spacing on bottom of page
    $('<br>').appendTo(footer);
}

function bindPopoverToTaggedItems() {
    
    // add click event handler to remove popover on another popover click event and window resize
    // use fiddle as an example - http://jsfiddle.net/AFffL/685/

    // refactor to use id lookup instead of for loop??
    // http://stackoverflow.com/questions/1946165/json-find-in-javascript

    // Bootstrap popovers assigned to .glossaryItems placed inside a <span> element
    // var container = $(app.view().contentElement()).find(".container");

    // alert(container);

    $.each($('span.glossaryItem'), function (index, element) {

        $(element).popover({
            placement: 'auto top',
            //trigger: 'manual',           // add back in with click event handler
            title: function () {
                if (sessionStorage.glossaryItems) {
                    var glossaryItems = $.parseJSON(sessionStorage.glossaryItems);
                    for (var i = 0; i < glossaryItems.length; i++) {
                        if (glossaryItems[i].id === $(element).attr("id")) return glossaryItems[i].title;
                    }
                }
                else return "Unavailable";                              // glossary items object not defined
                return "Unknown";                                       // cannot find glossary item in object
            },
            content: function () {
                if (sessionStorage.glossaryItems) {
                    var glossaryItems = $.parseJSON(sessionStorage.glossaryItems);
                    for (var i = 0; i < glossaryItems.length; i++) {
                        if (glossaryItems[i].id === $(element).attr("id")) return glossaryItems[i].content;
                    }
                }
                else return "Glossary is currently unavailable.";       // glossary items object not defined
                return "Item cannot be found in glossary.";             // cannot find glossary item in object
            }
            //, container: 'span'                   // original container
        });
    });

}

function addSourceReferences() {

   
    var pageSourceReferences = $.parseJSON(sessionStorage.pageSourceReferences);
    var sourceReferenceList = $.parseJSON(sessionStorage.sourceReferenceList);
    var sourceReferences = [];

    // find matching source references
    for (var i = 0; i < pageSourceReferences.length; i++) {
        //console.log(pageSourceReferences[i].page + "|" + app.view().content.context.id);
        if (pageSourceReferences[i].page === app.view().content.context.id) {
            for (var j = 0; j < sourceReferenceList.length; j++) {
                if (sourceReferenceList[j].id === pageSourceReferences[i].id) {
                    sourceReferences.push("<li>" + sourceReferenceList[j].reference + "</li>");
                }
            }
        }
    }
   
    // add source references to footer
    if (sourceReferences.length !== 0) {
        var footer = $(app.view().contentElement()).find(".container .pg-footer footer");
        $('<div>', { "class": "source", "html": "<h4>References:</h4>" }).appendTo(footer);
        $('<ul/>', { "class": "noindent", "html": sourceReferences.join("") }).appendTo(footer.find(".source"));
    }
   
}

function captureNextBreadcrumbItem(options) {

    if (typeof options.maxBreadcrumbs === "undefined") options.maxBreadcrumbs = -1;
    if (typeof options.fullHistory === "undefined") options.fullHistory = false;

    if (typeof (Storage) !== "undefined") {
        if (sessionStorage.breadcrumbList) {
            var breadcrumbList = $.parseJSON(sessionStorage.breadcrumbList);

            // manage history
            if (!options.fullHistory) {
                for (var i = 0; i < breadcrumbList.length; i++) {
                    if (breadcrumbList[i].href === options.href) {
                        breadcrumbList = breadcrumbList.slice(0, i);
                        break;
                    }
                }
            }

            // drop first item if at max length
            if (breadcrumbList.length === options.maxBreadcrumbs) breadcrumbList.shift();

            breadcrumbList.push({ "href": options.href, "title": options.title });
            sessionStorage.breadcrumbList = JSON.stringify(breadcrumbList);
        }
        else {
            sessionStorage.breadcrumbList = '[ { "href": "' + options.href + '", "title": "' + options.title + '" } ]';
        }
    }
}

function buildBreadcrumbHistory() {

    if (typeof (Storage) !== "undefined") {

        var breadcrumbHistory = "";
        var breadcrumbList = $.parseJSON(sessionStorage.breadcrumbList);

        for (var i = 0; i < breadcrumbList.length - 1; i++) {
            breadcrumbHistory = breadcrumbHistory + "<li><a href='#" + breadcrumbList[i].href + "'>" + breadcrumbList[i].title + "</a></li>";
        }
        //breadcrumbHistory = breadcrumbHistory + "<li class='active'>" + breadcrumbList[i].title + "</li>";

        return breadcrumbHistory;
    }
    else {
        return "<li class='active'>" + app.view().title + "</li>";
    }
}


Array.prototype.inArray = function (value, caseSensitive)
    // Returns true if the passed value is found in the
    // array. Returns false if it is not.
{
    var i;
    for (i = 0; i < this.length; i++) {
        // use === to check for Matches. ie., identical (===),
        if (caseSensitive) { //performs match even the string is case sensitive
            if (this[i].toLowerCase() == value.toLowerCase()) {
                return true;
            }
        } else {
            if (this[i] == value) {
                return true;
            }
        }
    }
    return false;
};
Array.prototype.removeByValue = function (val) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == val) {
            this.splice(i, 1);
            break;
        }
    }
}



//Used to handle listview clicks across all types of listviews
function listViewLinkClick(e) {

    //var pane = $("#leftPane").data("kendoMobilePane");
    //pane.navigate(e.dataItem.url);
    //$('#focusContainer').focus();



    var headerClass = app.view().header[0].children[0].children[0].className;
    var id = app.view().wrapper[0].attributes['id'].value;
    $('#' + id + ' .viewTitleStyle').attr('tabindex', '-1');

    //$('#medicines .viewTitleStyle').attr('tabindex', '-1');
    //$('#' + id + ' .viewTitleStyle').attr('aria-hidden', 'true');
    //$('#' + id + ' .viewTitleStyle').attr('role', 'presentation');
    //$('#' + id + ' .viewTitleStyle').attr('visibility', 'hidden');
    //var temp = $('#medicines .viewTitleStyle').text();

    $('#' + id + ' .viewTitleStyle').text("navigating");

    //console.log("id: " + id);
    // console.log("Tag: " + $('#' + id + ' .viewTitleStyle').text())
    $('#' + id + ' .viewTitleStyle').focus();

    //$('#focusContainer').focus();
    //$('#' + id + ' .viewTitleStyle').text(temp);
    //setTimeout(function(){ $('#medicines .viewTitleStyle').focus(); }, 2000);
    // $('#' + id + ' .viewTitleStyle').attr('aria-hidden', 'false');
    app.navigate(e.dataItem.url);
}


function navigateToURL(url) {
    //custom navigator class that makes sure the focus is set to the top of the page before the page moves, then actually does
    //the navigation.  

    var headerClass = app.view().header[0].children[0].children[0].className;


    //this IF should work, but for whatever reason, it doesn't focus with it here, so...bad code here we go
    //if (app.view().wrapper[0].attributes['id']) {

        var id = app.view().wrapper[0].attributes['id'].value;
        $('#' + id + ' .viewTitleStyle').attr('tabindex', '-1');
        $('#' + id + ' .viewTitleStyle').text("navigating");
        $('#' + id + ' .viewTitleStyle').focus();
    //}
    //else {
    //    console.log("Cannot find id:");
    //}
  
    app.navigate(url);
}


function onTabSelect(e) {
    //for 508 compliance, we need to give the tabs a state, using the aria-selected attribute
    
    var tabStrip = e.sender.element[0];
    
    e.sender.element[0].children[0].children
    for (var i = 0; i < tabStrip.childElementCount; i++) {
        tabStrip.children[i].setAttribute("aria-selected", false);
    }

    e.item[0].setAttribute("aria-selected", true);

   
}


function clearEmail() {
    removeView("#email-medical-team");
}


//error catching

 function failFileOp(error) {
            console.log("error source " + error.source);
            console.log("error target " + error.target);
            console.log("error code " + error.code);
 }

//javascript way to convert images to base64 encoded strings so we can send them through the web service

 function convertImgToBase64(url, callback, outputFormat) {
     console.log("converting image...");
     var canvas = document.createElement('CANVAS');
     var ctx = canvas.getContext('2d');
     var img = new Image;
     img.crossOrigin = 'Anonymous';
     img.onload = function () {
         canvas.height = img.height;
         canvas.width = img.width;
         ctx.drawImage(img, 0, 0);
         var dataURL = canvas.toDataURL(outputFormat || 'image/jpg');
         callback.call(this, dataURL);
         // Clean up
         canvas = null;
     };
     img.src = url;
 }



 function getFormattedDateString(d) {
     //need to get date in DD/MM/YYYY HH:mm:ss for web service call
     
     var  dformat = [(d.getMonth() + 1).padLeft(),
                   d.getDate().padLeft(),
                   d.getFullYear()].join('/') +
                   ' ' +
                 [d.getHours().padLeft(),
                   d.getMinutes().padLeft(),
                   d.getSeconds().padLeft()].join(':');
     
     return dformat;
 }