﻿var id;
var service;
var map;
var infowindow;

var radiusMiles = 200;
var radiusMeters = '16000';  //used for google maps api
var currentPosition;

// device APIs are available
function mapsInit() {
    var mapOptions = {
        center: { lat: -34.397, lng: 150.644 },
        zoom: 8
    };
    map = new google.maps.Map(document.getElementById('map-canvas'),
        mapOptions);

    //var btn = document.getElementById("btngelocation");
    //btn.addEventListener('click', getmylocation, false);

    infowindow = new google.maps.InfoWindow({
        disableAutoPan: true,
    });

    //pre-fetch anything VA related
    if (Object.keys(FACILITIES_DATA).length < 4) {
        GetFacilites();
    }

    if (!geocoder) {
        geocoder = new google.maps.Geocoder();
    }

}


function getmylocation() {
    id = navigator.geolocation.watchPosition(onMapSuccess, onMapError);

}

// The onSuccess method for  Geolocation
function onMapSuccess(position) {

    //Create a Google MAP
    var myLatLag = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
    currentPosition = position;

    //Set option for map so that is use latlng center
    var myoptions = { zoom: 12, center: myLatLag, mapTypeId: google.maps.MapTypeId.ROADMAP };

    //google map instance
    map = new google.maps.Map(document.getElementById("map-canvas"), myoptions);

    //add marker for our location
    var marker = new google.maps.Marker({ position: myLatLag, map: map, icon: 'http://maps.google.com/mapfiles/ms/icons/green-dot.png' });

    //now get the VA facilities to put on the map. 
    getVAHospitalsByRadiusAndPosition(radiusMiles, position.coords.latitude, position.coords.longitude);


    //console.log(coordinates.k);
    //console.log(coordinates.B);

    var request = {
        location: myLatLag,
        radius: radiusMeters,
        types: ['hospital']
    };

    service = new google.maps.places.PlacesService(map);
    service.nearbySearch(request, callback);

    //clear the watch so we can re-get the location later if needed
    navigator.geolocation.clearWatch(id);
}

function callback(results, status) {
   
    if (status == google.maps.places.PlacesServiceStatus.OK) {

        for (var i = 0; i < results.length; i++) {
            var place = results[i];
            if (results[i].name.indexOf("animal") < 0 && results[i].name.indexOf("veterenary") < 0 && results[i].name.indexOf("VA Medical") < 0 && results[i].name.indexOf("Express") < 0 && results[i].name.indexOf("Urgent Care") < 0 && results[i].name.indexOf("plastic surgery") < 0) {
                createMarker(results[i]);
            }
        }
    }
}
function createMarker(place) {
    var placeLoc = place.geometry.location;
    var marker = new google.maps.Marker({
        map: map,
        position: place.geometry.location,
        animation: google.maps.Animation.DROP
    });

    google.maps.event.addListener(marker, 'click', function () {
        infowindow.setContent("<div class='calloutWindow'><span class='header'>" + place.name + "</span><br /><span>" + place.vicinity + "</span><br /><a href='javascript:getDirections(\"" + place.vicinity + "\")' class='directionsLink'>Get Directions</a>");
        infowindow.open(map, this);
    });
}
// The  Callback use to  receive a PositionError object
function onMapError(error) {
    alert('Error Code: ' + error.code + ' Error Message: ' + error.message);
}
function getDirections(destination) {
    var platform = device.platform;
    var dest = destination.replace(/ /g, '+');
    var url;  


    if (platform === 'iOS') {
        url = 'http://maps.apple.com/?daddr=' + dest + '&saddr=' + currentPosition.coords.latitude + ',' + currentPosition.coords.longitude;
    }
    else {//if (platform === 'Android') {
        url = 'http://maps.google.com/maps?daddr=' + dest + '&saddr=' + currentPosition.coords.latitude + ',' + currentPosition.coords.longitude + '&dirflg=d';
    }

    window.open(url, '_system');

    console.log(device.platform);
    console.log(url);

}

function createVAMarkerFromArrayItem(place) {
  
    var myLatLag = new google.maps.LatLng(place.LATITUDE, place.LONGITUDE);


    var marker = new google.maps.Marker({
        map: map,
        position: myLatLag,
        icon: 'images//icons//va-pin-blue-64x64.png',
        animation: google.maps.Animation.DROP
    });

    var viscinity = place.ADDRESS + ', ' + place.CITY + ', ' + place.STATE;
    google.maps.event.addListener(marker, 'click', function () {
        infowindow.setContent("<div class='calloutWindow'><span class='header'>" + place.FAC_NAME + "</span><br /><span>" + viscinity + "</span><br /><a href='javascript:getDirections(\"" + viscinity + "\")' class='directionsLink'>Get Directions</a>");
        infowindow.open(map, this);
    });
}
function getVAHospitalsByRadiusAndPosition(myRadius, myLat, myLon) {

    console.log("VA Hospitals at: " + myLat + " " + myLon);
    if (isFacilityDataLoaded) {
        var vaHospitalArray = getFacilitiesByRadius(FACILITIES_DATA, myRadius, myLat, myLon);

        console.log("# VA Hospitals: " + vaHospitalArray.length)
        for (var i = 0; i < vaHospitalArray.length; i++) {
            //place a pin
            createVAMarkerFromArrayItem(vaHospitalArray[i]);
        }
    }
    else {
        GetFacilites();
    }
}

function codeAddressMaps() {

    var address = $('#mapSearchAddress').val();

    geocoder.geocode({ 'address': address }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {

            var myLatLag = new google.maps.LatLng(results[0].geometry.location.lat(), results[0].geometry.location.lng());
            currentPosition = myLatLag;

            //Set option for map so that is use latlng center
            var myoptions = { zoom: 12, center: myLatLag, mapTypeId: google.maps.MapTypeId.ROADMAP };

            //google map instance
            map = new google.maps.Map(document.getElementById("map-canvas"), myoptions);

            //add marker for our location
            var marker = new google.maps.Marker({ position: myLatLag, map: map, icon: 'http://maps.google.com/mapfiles/ms/icons/green-dot.png' });

            //now get the VA facilities to put on the map. 
            getVAHospitalsByRadiusAndPosition(radiusMiles, results[0].geometry.location.lat(), results[0].geometry.location.lng());


            //console.log(coordinates.k);
            //console.log(coordinates.B);

            var request = {
                location: myLatLag,
                radius: radiusMeters,
                types: ['hospital']
            };

            service = new google.maps.places.PlacesService(map);
            service.nearbySearch(request, callback);

            //clear the watch so we can re-get the location later if needed
            navigator.geolocation.clearWatch(id);


        } else {
            console.log('Geocode was not successful for the following reason: ' + status);
        }
    });
}





///////////////////////////////////////////////////////////////////////
//** Help Near Home services
//////////////////////////////////////////////////////////////////////


var FACILITES_FILE;			// The file that stores the facilites data.
var UPDATE_NOW = 60;		// Days until next db update.
var FACILITIES_DATA = {};	// Holds the data consumed from the web service or read from the disk
var geocoder;
var clocation = { lat: 38.8951, lon: -77.0367, title: 'Current location' };
var radius = 200;            // radius to search from current location, in miles
var filterString = "2,7,10,11"  // filter 
var facilities = [];        // Final list of relevant facilities
var facilitiesFileName = "facilities.txt";
var isFacilityDataLoaded = false;
var isHelpHomeSetup = false;
var clocationAddress;

var helpNearHomeData = new kendo.data.DataSource({
    data: [],
    schema: {
        model: { id: "FAC_ID" }
    }
});

//html/backpack/help-near-home-details.html?isSetup=1
function helpHomeShow(e) {

    //we need to adjust the instructions based on if this is a setup action or a general search action
    if (e.view.params.isSetup) {
        $("#setupHelpHomeInstructions").show();
        $("#generalHelpHomeInstructions").hide();
        isHelpHomeSetup = true;

        //BUG:  this doesn't work every so often when the 'customize home page' page is used first.  no idea why and no time to debug
    //    var navbar = app.view()
    //.header
    //.find(".km-navbar")
    //.data("kendoMobileNavBar");

        //    navbar.title("Settings");

    } else {
        $("#generalHelpHomeInstructions").show();
        $("#setupHelpHomeInstructions").hide();
        isHelpHomeSetup = false;
    }
}



function helpHomeInit() {

      
    $('#findFacilitiesButton').kendoMobileButton({ click: codeAddress });

    if (!geocoder) {
        geocoder = new google.maps.Geocoder();
    }

    if (Object.keys(FACILITIES_DATA).length < 4) {
        GetFacilites();
    }
    else {
        //ShowFacilities();
        // getFacilitiesByRadius(FACILITIES_DATA, radius);

        // HTML5 geolocation
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(successFunction, errorFunction);
        }
    }

    $("#helpnearhome-listview").kendoMobileListView({
        dataSource: helpNearHomeData,
        template: $("#helpNearHomeTemplate").html(),
        click: onHelpNearHomeClick

    });

    //TEMPORARY - loading from disk not workign properly, comment this out for now and just download every time
    // Check if localStorage is supported
    //if (typeof (Storage) !== "undefined") {

    //    if (localStorage.lastUpdated) {
    //        //User has visited page before.
    //        //Check to see how much time has passed since last update.
    //        //Update facilities data on the file system if needed

    //        //Set the two dates
    //        var updated = new Date(localStorage.lastUpdated);
    //        var today = new Date();
    //        //updated.setDate(updated.getDate() - 61); // for testing. set the date above/below UPDATE_NOW
    //        //console.log(updated);
    //        //console.log('Days since the last update: ' + Date.dateDiff('d', updated, today));

    //        if (Date.dateDiff('d', updated, today) > UPDATE_NOW) {
    //            //Update db
    //            console.log("localStorage.lastUpdated found but database is out of date. Updating database...");
    //            GetFacilites();
    //        } else {
    //            //Read db
    //            console.log("localStorage.lastUpdated found and current. Reading database...");
    //            ShowFacilities();
    //            //window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, fail);
    //        }
    //    } else {
    //        //Update/create db
    //        console.log("localStorage.lastUpdated was NOT found. Creating database...");
    //        GetFacilites();
    //    }

    //} else {
    //    //ugh
    //    console.log("No Web Storage support..");
    //}

}

function distance(obj) {
    //console.log("" + displayPropertyNames(obj));

    var R = 6371; // km
    var dLat = (obj.lat2 - obj.lat1) * Math.PI / 180;
    var dLon = (obj.lon2 - obj.lon1) * Math.PI / 180;
    var lat1 = obj.lat1 * Math.PI / 180;
    var lat2 = obj.lat2 * Math.PI / 180;

    var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.sin(dLon / 2) * Math.sin(dLon / 2) * Math.cos(lat1) * Math.cos(lat2);

    //console.log("" + obj.lat1);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    var d = R * c;
    var m = d * 0.621371;
    return {
        km: d,
        m: m
    }
}


function ShowFacilities() {
    //read db and display results.. to be done
    console.log("ShowFacilities called...");
    var results = null;

    var r = displayResults(results);
    // do something
}

function displayResults(results) {
    //  window.requestFileSystem(cordova.file.dataDirectory + facilitiesFileName, 0, gotFileToRead, readFailed);
    window.resolveLocalFileSystemURL(cordova.file.dataDirectory + facilitiesFileName, gotFileToRead, readFailed);
}
function gotFileToRead(fileEntry) {
    var loc;
    console.log("gotFileToRead called...");

    fileEntry.file(function (file) {

        var reader = new FileReader();

        reader.onloadend = function (evt) {
            console.log("read success");
            var theResults = jQuery.parseJSON(evt.target.result);
            FACILITIES_DATA = theResults;
            //console.log(FACILITIES_DATA);
            //console.log("" + displayPropertyNames(theResults.RESULTS[1]));
            getFacilitiesByRadius(theResults, radius);
            //return facilities;

        };
        reader.readAsText(file);

    });
}

function getFacilitiesByRadius(facilityData, myRadius, lat, lon) {
    console.log("get facilities by Radius called");

    //clear out existing facilities list
    facilities.length = 0;

    for (var name in facilityData.RESULTS) {
        point = { lat: facilityData.RESULTS[name].LATITUDE, lon: facilityData.RESULTS[name].LONGITUDE };
        dist = distance({
            lat1: lat,
            lon1: lon,
            lat2: point.lat,
            lon2: point.lon
        });

        if (dist.m < myRadius) {

            //so now verify that this facility is in the list of accepted facilities
            var typesArray = filterString.split(',');
            //for (var i = 0; i < typesArray.length; i++) {
            //    if(parseInt(typesArray[i])
            //}

            // point.distance = +dist.m;
            facilityData.RESULTS[name].DISTANCE = parseFloat(Math.round(dist.m * 100) / 100).toFixed(2);
            facilityData.RESULTS[name].RAW_DISTANCE = dist.m;
            facilities.push(facilityData.RESULTS[name]);


            //console.log("" + " " + theResults.RESULTS[name].CITY + " "  + dist.m);
        }

    }


    // for (var i = 0; i < facilities.length; i++) {
    // console.log("Distance: " + facilities[i].DISTANCE + " " + facilities[i].CITY);
    // }
    // console.log("Found " + facilities.length + " matching facilities");


    return facilities;
   

}

function refreshHelpNearHomeList(facilitiesArray) {

    //take an array and rebind the listview
    var jsonObject = jQuery.parseJSON(JSON.stringify(facilitiesArray))
  
    helpNearHomeData.data(jsonObject);
    helpNearHomeData.sort({ field: "RAW_DISTANCE", dir: "asc" });

   
}

function onHelpNearHomeClick(e) {

    //var pane = $("#leftPane").data("kendoMobilePane");
    //pane.navigate(e.dataItem.url);
    //console.log("fac details clicked");
    navigateToURL("html/backpack/help-near-home-details.html?id=" + e.dataItem.FAC_ID);
}
//function gotFileToRead(fileSystem) {
//    var loc;
//    console.log("gotFileToRead called...");

//    fileSystem.root.getFile(cordova.file.dataDirectory + facilitiesFileName, null,
//           function (fileEntry) {

//               fileEntry.file(function (_file) {

//                   var reader = new FileReader();

//                   reader.onloadend = function (evt) {
//                       console.log("read success");
//                       var theResults = jQuery.parseJSON(evt.target.result);
//                       //console.log(evt.target.result);
//                       //console.log("" + displayPropertyNames(theResults.RESULTS[1]));
//                       for (var name in theResults.RESULTS) {
//                           console.log("Name: " + name);
//                           point = { lat: theResults.RESULTS[name].LATITUDE, lon: theResults.RESULTS[name].LONGITUDE };
//                           dist = distance({
//                               lat1: clocation.lat,
//                               lon1: clocation.lon,
//                               lat2: point.lat,
//                               lon2: point.lon
//                           });

//                           if (dist.m < radius) {
//                               // point.distance = +dist.m;
//                               theResults.RESULTS[name].DISTANCE = dist.m;
//                               facilities.push(theResults.RESULTS[name]);
//                               facilities.sort(sortByProperty('DISTANCE'));

//                               //console.log("" + " " + theResults.RESULTS[name].CITY + " "  + dist.m);
//                           }

//                       }
//                       for (var i = 0; i < facilities.length; i++) {
//                           console.log("Distance: " + facilities[i].DISTANCE + " " + facilities[i].CITY);
//                       }
//                       console.log("List Done");
//                       //return facilities;

//                   };
//                   reader.readAsText(_file);

//               });
//           }
//       );
//}

function readFailed(e) {
    console.log("FileSystem Error");
    console.dir(e);
}

function GetFacilites() {
    $.ajax({
        type: "GET", // Can be changed to POST but will fail with no message if dataType=jsonp
        url: "http://www.va.gov/webservices/fandl/facilities.cfc",
        // There are many more Region Ids. need to have them ALL (Reg_id: comma delimited list). Check http://www.va.gov/webservices/fandl/documentation/fandl.cfm for the region lookup.
        // facility type (Fac_Type_ID: comma delimited list) 2,7,10,11 for Hospitals and clinics. Check http://www.va.gov/webservices/fandl/documentation/fandl.cfm for other types
        // though we set facility type = 0 to fetch everything so only the initial load takes time.
        data: { license: "ACE6A9C6-B1E0-D397-F8679FCC12C136DB", method: "Facility_byRegionIDandType_detail_array", ReturnFormat: "json", Reg_id: "1,2,3,4,5,6,7,8,9,10,11,12,15,16,17,18,19,20,21,22,23,36,37,38,46,47,50,51,52,53", Fac_Type_ID: filterString },
        contentType: "application/text; charset=utf-8", // prefered josn but return is malformed. swiching to json will result in a "success" but the operation will fail
        dataType: "text", // jsonp will be successfull but parse will fail
        success: OnGetFacilitesSuccess,
        error: OnGetFacilitesError
    });
    console.log('GetFacilites called...');
}

function OnGetFacilitesSuccess(data, status) {
    // console.log("Get Facilities Success, status : " + status + " Data: " + data);

    //Update lastUpated in localStorage
    localStorage.lastUpdated = new Date();

    // fix malformed json data
    FACILITIES_DATA = jQuery.parseJSON(data.substring(2));
    isFacilityDataLoaded = true;
  
    // need to store to local file
    //window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, writeFailed);

    //take that data and update the UI
    //if (app.view().id == "help-near-home") {
        refreshHelpNearHomeList(getFacilitiesByRadius(FACILITIES_DATA, radius, clocation.lat, clocation.lon));
    //}
    //else {
        //TODO:  refresh list based on current location
    //}

    //then write the data to disk for later usage
    window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function (dir) {

        console.log("Attempting to write to: " + facilitiesFileName);

        try {
            dir.getFile(facilitiesFileName, { create: true }, function (file) {
                console.log("facilities file gotten");
                var logOb = file;

                logOb.createWriter(function (fileWriter) {


                    console.log("Writing saved facilities data");
                    // fileWriter.seek(fileWriter.length);
                    fileWriter.write(FACILITIES_DATA);

                }, failFileOp);

            });
        }
        catch (e) {
            console.log("write file failed");
            writeFailed(e);
        }



    }, failFileOp);
}


function OnGetFacilitesError(request, status, error) {
    console.log(" Facilities error : " + error + " " + request.status)
}

function gotFS(fileSystem) {
    fileSystem.root.getFile("facilties.txt", { create: true, exclusive: false }, gotFileEntry, writeFailed);

}

function gotFileEntry(fileEntry) {
    fileEntry.createWriter(gotFileWriter, writeFailed);
}

function gotFileWriter(writer) {
    writer.onwriteend = function (evt) {
        console.log("contents of file now " + FACILITIES_DATA);
        ShowFacilities();
    };
    writer.write(FACILITIES_DATA);
}

function writeFailed(error) {
    console.log(error.code);
}

// Utilities //
Date.dateDiff = function (datepart, fromdate, todate) {
    datepart = datepart.toLowerCase();
    var diff = todate - fromdate;
    var divideBy = {
        w: 604800000,
        d: 86400000,
        h: 3600000,
        n: 60000,
        s: 1000
    };

    return Math.floor(diff / divideBy[datepart]);
}

function displayPropertyNames(thisObject) { // used to display object propery names
    var names = '';
    for (var name in thisObject) names += name + ": " + thisObject[name] + "\n";
    return names;
}

function sortByProperty(property) {
    'use strict';
    return function (a, b) {
        var sortStatus = 0;
        if (a[property] < b[property]) {
            sortStatus = -1;
        } else if (a[property] > b[property]) {
            sortStatus = 1;
        }

        return sortStatus;
    };
}


////////////////////////////////




//Get the latitude and the longitude;
function successFunction(position) {
    var lat = position.coords.latitude;
    var lng = position.coords.longitude;
    codeLatLng(lat, lng);
    refreshHelpNearHomeList(getFacilitiesByRadius(FACILITIES_DATA, radius, clocation.lat, clocation.lon));
}

function errorFunction() {
    console.log("Geocoder failed");
}


function codeLatLng(lat, lng) {
    var str = "";

    var latlng = new google.maps.LatLng(lat, lng);

    geocoder.geocode({ 'latLng': latlng }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            //console.log(results);
            if (results[1]) {
                //formatted address
                str += results[0].formatted_address + '<br><br>';
                clocationAddress = results[0].formatted_address;
                //alert(results[0].formatted_address)
                //find country name
                for (var i = 0; i < results[0].address_components.length; i++) {
                    for (var b = 0; b < results[0].address_components[i].types.length; b++) {

                        //there are different types that might hold a city admin_area_lvl_1 usually does in come cases looking for sublocality type will be more appropriate
                        if (results[0].address_components[i].types[b] == "administrative_area_level_1") {
                            //this is the object you are looking for
                            city = results[0].address_components[i];
                            break;
                        }
                    }
                }
                //alert(city.short_name + " " + city.long_name)
                var range = GeoLocation.buildLocationRange(lat, lng, 20);
                var range2 = GeoLocation.buildLocationRange(lat, lng, 40);
                //document.getElementById("results").innerHTML = str + "<br><a href=\"https://maps.google.com?saddr=Current+Location&daddr=43.12345,-76.12345\">Map it</a> Range: minLat: " + range.minLat + ", maxLat: " + range.maxLat + " minLon: " + range.minLon.toFixed(2) + ", maxLon: " + range.maxLon.toFixed(2);

                //document.getElementById("results").innerHTML += "<BR><BR>" + str + "<br>Range: minLat: " + range2.minLat.toFixed(2) + ", maxLat: " + range2.maxLat.toFixed(2) + " minLon: " + range2.minLon.toFixed(2) + ", maxLon: " + range2.maxLon.toFixed(2);
            } else {
                console.log("No results found");
            }
        } else {
            console.log("Geocoder failed due to: " + status);
        }
    });
}

function codeAddress() {

    //var selectedValues = $('#facilityType').val();

    //if (selectedValues.length > 0) {
    //    //we need SOME type to search for, otherwise this is uninteresting
    //    //we join and split here because there are multiple values already comma delimited from the dropdown, rather than just single values
    //    filterString = selectedValues.join();
    //}

    radius = parseInt($('#mileRadiusHelp').val());


    var address = $('#zipCodeHelp').val();
    geocoder.geocode({ 'address': address }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {

            codeLatLng(results[0].geometry.location.lat(), results[0].geometry.location.lng())
            clocation.lat = results[0].geometry.location.lat();
            clocation.lon = results[0].geometry.location.lng();
            refreshHelpNearHomeList(getFacilitiesByRadius(FACILITIES_DATA, radius, clocation.lat, clocation.lon));

        } else {
            console.log('Geocode was not successful for the following reason: ' + status);
        }
    });
}

